<?php

namespace Delo;

class DebugInfo
{
    static protected $instance = null;
    /** @var array */
    private $info = [];

    /**
     * Метод для доступа к одному и тому экземпляру класса
     * @return DebugInfo
     */
    static public function getInstance()
    {
        if (null === static::$instance) {
            $className = get_called_class();
            static::$instance = new $className();
        }
        return static::$instance;
    }

    /**
     * Запоминает сообщение
     * @param string $message
     * @return int id сообщения
     */
    public function set($message)
    {
        $c = array_push($this->info, $message);
        return $c - 1;
    }

    /**
     * Добавляет в конец сообщения - ok
     * @param int $messageId id сообщения
     * @param string $additionMessage добавочное сообщение
     */
    public function setOk($messageId, $additionMessage = 'ok')
    {
        if (!empty($this->info[$messageId])) {
            $this->info[$messageId] .= $additionMessage;
        }
    }

    /**
     * Возвращает собранную информацию обрамленную в кусок xml
     * @return string
     */
    public function getXml()
    {
        if (empty($this->info)) {
            return '';
        }
        $out = "<debug>\n";
        foreach ($this->info as $info) {
            $out .= '<info><![CDATA[' . $info . "]]></info>\n";
        }
        $out .= "</debug>\n";
        return $out;
    }
}
